automata Task : i = 1..4;
clock x[1..total(Task)];
register run, pend[1..total(Task)];

--------------------------------------------------------------------------
automaton Task[i] {
initially Idle and 
          run = 0 &             --  run = 0      =>  no task running, 
                                --  run = i      =>  Task[i] running
          pend[i] = 0 and       --  pend[i] = 1  =>  Task[i] pending
          x[i] = 0;             --  x[i]         =>  local clock
  mode Idle {
    invariant True;
    when x[i] >= 20 and run = 0 & pend[forall < i] = 0 may goto Run; 
                                               x[i] := 0; run := i;
    when x[i] >= 20 and ~(run = 0) may goto Pend; x[i] := 0; pend[i] := 1;
    when x[i] >= 20 and ~(run = 0) & pend[forall < i] = 1 may goto Pend; 
                                                  x[i] := 0; pend[i] := 1;
  }
  mode Run{
    invariant x[i] < 1; 
    when x[i] < 1 may goto Idle; x[i] := 0; run := 0;
  }
  mode Pend{
    invariant x[i] <= 19;
    when x[i] <= 19 and run = 0 & pend[forall < i] = 0 may goto Run; 
                                             x[i] := 0; run := i; pend[i] := 0;
    when x[i] > 19 and ~(run = 0) may goto Dead;
  }
  mode Dead{
    invariant True;
  }
}

manipulation
----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    transition_bypass();(No reduction achievable)
--    shield_variables(); (No reduction achievable)
--  normalize_region();   (Not APPLICABLE because this is an asymmetric system)
--  print_graph();
----------------------------------------
