#ifndef __PRINT_H
#define __PRINT_H
/* print.h */
extern int output(char *);		   	/* output some string */
extern int print_auto_dec(void);		/* print automata declarations*/
extern int print_vars(void);			/* print variables */
extern int print_init_cond(struct automaton *);/* print initial condition */
extern int print_clkconj(struct clkconj_type *);/* print clkconj */
extern int print_boolconj(struct boolconj_type *);/* print boolconj */
extern int print_boolexp(struct boolexp_type *);/* print boolexp */
extern int print_inv(struct mode_type *);	/* print invariant */
extern int print_trigger(struct transition_type *);	/* print trigger cond */
extern int print_tr_assignment(struct transition_type *);/* print assignment */
extern int print_assignment(struct assign_type *);   /* assignment (assign)*/
extern int print_assignment1(struct assign_type *);  /* 1 assignment (assign)*/
extern int print_trans(struct transition_type *);	/* print transition */
extern int print_mode(struct mode_type *);	/* print mode */
extern int print_automaton(struct automaton *);	/* print automaton */
extern int print_automata(void);
extern char *naming_fn(bdd_manager, bdd, pointer);/* naming function for bdds */
extern int print_bdd(bdd);			/* print a bdd */
extern int print_prop_bdds(void);		/* print proposition BDDs */
extern int print_thread(struct thread_type *);   /* print a thread */
extern int print_counts(struct thread_type *);	  /* print the count status */
extern int outputline(void);
extern int print_prompt(void);            /* print prompt for interactive mode" */
extern char *get_graph_name(struct thread_type *);
extern int view_graph(struct thread_type *);
extern int print_literals(struct clkconj_type *);
extern int print_graph_list();
extern int print_action_list(struct action_type *);
extern int print_action(struct action_type *);
extern int print_one_clkconj(struct clkconj_type *);
extern int print_tctl_spec(struct spec_type *);
extern int print_sync(struct automaton *);
extern int print_tr_sync(struct transition_type *);
#endif
