#ifndef __SYMMETRY_H
#define __SYMMETRY_H

extern int *ordered_clocks;
extern struct mode_type *CURR_MODE;
extern struct a23tree_type *perm_tree;

extern int eliminate_transition(struct transition_type *, struct mode_type *);
extern int remove_irreachable_mode(struct thread_type *);
extern int init_permutation(void);
extern int sort_clocks(struct zone_type*);
extern int order_compare(int *, int *);
extern int different_order(int *, int *);
extern int move_before_sorted(int, int, struct zone_type *);
extern int move_after(int, int);
extern int perm_index(int, int *);
extern int install_permutation(struct transition_type *, struct mode_type *,
                               struct mode_type *, struct mode_perm_type *, 
                               struct thread_type *);
extern struct zone_type *permute_zone(struct zone_type *, int *, 
                                      struct thread_type *);
extern int print_ordered_clocks(void);
extern struct zone_type *perm_kclosure_zone(struct zone_type *);

extern int normalize_regions(struct thread_type *);
extern int is_normal_zone(void);

extern int *copy_permutation(int *, int *);
extern int *inverse_permutation(int *);
extern int *compose_permutation(int *, int *);

extern struct mode_type *successor_mode(struct mode_type *, 
                                        struct transition_type *);


extern struct mode_perm_type *create_normal_mode_list(struct thread_type *);
extern bdd permute_bdd(bdd, int *);
extern struct boolconj_type *permute_boolconj(struct boolconj_type *, int *); 
extern struct boolconj_type *permute_boolconj1(struct boolconj_type *, int *); 
extern struct mode_type *normal_mode(struct mode_type *, 
                                     struct mode_perm_type *,
                                     struct thread_type *);
extern int *mode_perm(struct mode_type *, struct mode_perm_type *, 
                      struct thread_type *);
extern int compact_reduce(struct mode_type *, struct transition_type *, 
                          struct mode_perm_type *, struct thread_type *);
extern int reduce_multigraph(struct thread_type *);
extern int permute_variable(int, int *);
extern int permute_assignment(struct assign_type *, int *);
extern struct clkconj_type *permute_clkconj(struct clkconj_type *, int *);
extern int permute_prp_trigger(struct boolconj_type *, int *);
extern struct transition_type *
       permute_transition(struct transition_type *, int *);
extern int install_one_trigger_bdd(struct transition_type *);
extern int print_trans_permutation(struct transition_type *);
extern int print_perm(int *);
extern int is_normal_trans(struct transition_type *);
extern int copy_clock_order(int *);
extern char *permute_mode_name(struct mode_type *, int *, char ***);

extern int *copy_permutation(int *, int *);

extern struct mode_type *compose_modes(struct mode_type *, struct mode_type *);
extern struct mode_type *successor_mode(struct mode_type *, 
                                        struct transition_type *);

extern int normal_index_compare(const int *, const int *);
extern int is_normal_perm(int *);
extern int dvl_compare(struct boolconj_type *, struct boolconj_type *);
extern int assignment_compare(struct assign_type *, struct assign_type *);
extern int same_trans(struct transition_type *, struct transition_type *);
extern int corr_trans(struct transition_type *, struct transition_type *);
extern int remove_dormant_cycles(struct thread_type *);
#endif
