#ifndef __ZONEMAN_H
#define __ZONEMAN_H

extern int total_clocks;
extern int num_clocks;
extern int boob;
extern int *clock_indexes;

extern struct a23tree_type *zone_tree;

extern int init_zone_management();
extern struct zone_type *alloc_zone(struct thread_type *);
extern struct zone_type *init_zone(struct zone_type *, struct clkconj_type *, 
                                   struct thread_type *);
extern struct zone_type *zone(struct clkconj_type *, struct thread_type *);

extern int print_clock_indexes(struct zone_type *);
extern int access_clock(struct variable_type *, struct thread_type *);

extern int new_index(int, struct zone_type *);
extern int old_index(int someclk, struct zone_type *);
extern int clk_not_seen(int *, int);
extern void free_zone(struct zone_type *);

extern struct zone_type *zone_copy(struct zone_type *);
/*
extern struct zone_type *zone_and(struct zone_type *, struct zone_type *);
extern struct zone_type *non_empty_zone_and( struct zone_type *,
                                             struct zone_type *,
                                             struct zone_type *);
*/

extern int zone_comp(struct zone_type *, struct zone_type *);
extern int install_clkconj_zones();
extern int out_of_bound(struct zone_type *);
extern struct zone_type *normalize_zone(struct zone_type *);
extern struct zone_type *init_reduce_zone(struct zone_type *);
extern struct zone_type *substitute_zone(struct zone_type *);
extern struct zone_type *reduce_zone(struct zone_type *);
extern struct zone_type *instantiate_zone(struct zone_type *);
extern struct clkconj_type *zone2clkconj(struct zone_type *);
extern struct zone_type *kclosure_zone(struct zone_type *);

extern struct zone_type *process_zone_max_const(struct zone_type *);
extern void print_zone(struct zone_type *);

extern int clk_index_compare(struct zone_type *, struct zone_type *);
extern int clk_index_diff(struct zone_type *, struct zone_type *);
extern int both_out_of_bounds(struct zone_type *, struct zone_type *);

struct zone_type {
  int index;
  int **relop;
  int **diff;
  int *clk_index;
} ;

#endif
